/*
 *   mysost.c
 *   mysost           Vers. 0.0.4
 *                    Copyright (C)  2002-2005  Matteo Nastasi
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *     CONTACT:    nastasi@alternativeoutput.it
 *                 matteo.nastasi@milug.org
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc,char **argv)
{
  int i, e, d = 0, st, vst, c, l, c_in=0, c_ot=0, *pi[2],ibf;
  int raw, luno, ldue, lmax;
  char *sosta, *s_in, *s_ot, *pb[2], *arv[3];

  //NODBG fprintf(stderr, "START\n");
  if (argc < 3) {
    fprintf(stderr,"\nUSAGE\n%s [-r|--] <orig> <sost>\n",argv[0]);
    fprintf(stderr,"  where (without \"-r\" option) in <orig> or <sost> you can use:\n");
    fprintf(stderr,"    X       all printable characters\n");
    fprintf(stderr,"    \\n      LF\n");
    fprintf(stderr,"    \\r      CR\n");
    fprintf(stderr,"    \\t      TAB\n");
    fprintf(stderr,"    \\oNNN   char code in octal rapresentation\n");
    fprintf(stderr,"    \\dNNN   char code in decimal rapresentation\n");
    fprintf(stderr,"    \\xNN    char code in exadecimal rapresentation\n\n");
    exit(1);
  }
    
  raw = 0;
  if (!strcmp(argv[1], "-r")) {
    raw = 1;
    d = 1;
  }
  else if (!strcmp(argv[1], "--")) {
    d = 1;
  }
  else 
    d = 0;

  arv[1] = argv[1+d];
  arv[2] = argv[2+d];

  //NODBG fprintf(stderr, "UNO [%s] DUE [%s]\n", arv[1], arv[2]);
  luno = strlen(arv[1]);
  ldue = strlen(arv[2]);
  lmax = (luno > ldue ? luno : ldue);
    
  if ((sosta = malloc(lmax + 10)) == NULL)
    exit(2);
  if ((s_in = malloc(lmax + 10)) == NULL)
    exit(2);
  if ((s_ot = malloc(lmax + 10)) == NULL)
    exit(2);
    
  pb[0] =  s_in; pb[1] =  s_ot;
  pi[0] = &c_in; pi[1] = &c_ot;

    
  for (i=0 ; i<2 ; i++) {
    //NODBG fprintf(stderr,"LOOP I\n");
    l = strlen(arv[1+i]);
    st = 0;
    for (e = 0,*pi[i] = 0; e<l ; e++) {
      //NODBG fprintf(stderr,"LOOP E [%c]\n", arv[1+i][e]);
      if (st == 0) {
	//NODBG fprintf(stderr,"ST == 0\n");
	if (arv[1+i][e] == '\\' && !raw) {
	  st = 1;
	  continue;
	}
	else {
	  //NODBG fprintf(stderr,"  PRE [%d] [%d] [%d]\n", i, e, *pi[i]);
	  pb[i][*pi[i]] = arv[1+i][e];
	  (*(pi[i]))++;
	  //NODBG fprintf(stderr,"  POST\n");
	}
      }
      else {
	//NODBG fprintf(stderr,"ST != 0\n");
	if (arv[1+i][e] == 'r')
	  pb[i][*pi[i]] = '\r';       
	else if (arv[1+i][e] == 'n')
	  pb[i][*pi[i]] = '\n';       
	else if (arv[1+i][e] == 't')
	  pb[i][*pi[i]] = '\t';       
	else if (arv[1+i][e] == 'x') {
	  if (arv[1+i][e+1] == '\0' || arv[1+i][e+2] == '\0')
	    exit (2);
	  memcpy(sosta,&(arv[1+i][e+1]),2);
	  sosta[2] = '\0';
	  sscanf(sosta,"%x",&ibf);
	  pb[i][*pi[i]] = ibf;
	  e+=2;
	}
	else if (arv[1+i][e] == 'o') {
	  if (arv[1+i][e+1] == '\0' || arv[1+i][e+2] == '\0' || 
	      arv[1+i][e+3] == '\0')
	    exit (2);
	  memcpy(sosta,&(arv[1+i][e+1]),3);
	  sosta[3] = '\0';
	  sscanf(sosta,"%o",&ibf);
	  pb[i][*pi[i]] = ibf;
	  e+=3;
	}
	else if (arv[1+i][e] == 'd') {
	  if (arv[1+i][e+1] == '\0' || arv[1+i][e+2] == '\0' || 
	      arv[1+i][e+3] == '\0')
	    exit (2);
	  memcpy(sosta,&(arv[1+i][e+1]),3);
	  sosta[3] = '\0';
	  sscanf(sosta,"%d",&ibf);
	  pb[i][*pi[i]] = ibf;
	  e+=3;
	}
	else if (arv[1+i][e] == '\0')
	  pb[i][*pi[i]] = '\0';       
	else
	  pb[i][*pi[i]] = arv[1+i][e];
	st = 0;
	(*(pi[i]))++;
      }
      //NODBG fprintf(stderr,"ST == 0 (fineif)\n");
    }
  }
  st = 0;
  while ((c = fgetc(stdin)) != EOF) {
    //NODBG fprintf(stderr,"QUI [%c] c_in[%d]\n", c, c_in);
    if (c_in == 1) {
      if (c == s_in[0])
	fwrite(s_ot,1,c_ot,stdout);
      else
	fputc(c,stdout);
      //NODBG fprintf(stderr,"PRE CONTINUE\n");
      continue;
    }
    //NODBG fprintf(stderr,"PRE IF\n");
    if (st == 0 && c != s_in[0]) {
      fputc(c,stdout);
      //NODBG fprintf(stderr,"PRE CONTINUE2\n");
      continue;
    }
    else {
      //NODBG fprintf(stderr,"IN ELSE\n");
      if (c == s_in[st]) {
	if ((st + 1) == c_in) {
	  fwrite(s_ot,1,c_ot,stdout);
	  st = 0;
	}
	else 
	  st++;
	continue;
      }
      else {
	//NODBG fprintf(stderr,"IN ELSE2\n");
	memcpy(sosta,s_in,st);
	sosta[st] = c;
	st++;
	vst = st;
	for ( ; st>0 ; st--)
	  if (!memcmp(&sosta[vst-st],s_in,st))
	    break;
	fwrite(sosta,1,vst-st,stdout);
      }
    }
    //NODBG fprintf(stderr,"FINE WHILE\n");
  }
  //NODBG fprintf(stderr,"POST WHILE\n");
  /* stampa eventuale buffer incompleto */
  if (st)
    fwrite(s_in,1,st,stdout);
  //NODBG fprintf(stderr,"POST WHILE2\n");
    
  fclose(stdout);
  exit(0);
  return (0);
}
   
